(*
   P R L I B . P A S
   Packet-Radio Pascal-Library fr Turbo Pascal 4.0
*)

unit PRlib;

interface

uses dos,crt,PRDefs;


  PROCEDURE Fenster (X, Y, Br, Ho : INTEGER; Kopf : str80);
  PROCEDURE Neu_Bild;
  PROCEDURE Status2;
  PROCEDURE Triller;
  PROCEDURE C_Bell;
  PROCEDURE D_Bell;
  procedure Daten_Bell;
  FUNCTION  str_int(Zeile : str6):INTEGER;
  procedure clr_filemenue;
  procedure File_error(Fname: str60);
  PROCEDURE openSaveFile(Kanal : INTEGER);
  PROCEDURE Cursor_aus;
  PROCEDURE Cursor_ein;
  FUNCTION  int_str(i : LongInt) : str8;
  PROCEDURE beep(Ton,Laenge : INTEGER);
  FUNCTION  Date : str11;
  FUNCTION  Time : str8;
  FUNCTION  FormatStr (Dezimal : longInt ; Stellenzahl : INTEGER) : string;
  FUNCTION  HEX (Dezimal : longInt ; Stellenzahl : INTEGER) : string;
  PROCEDURE Filereset(var datei: text);
  procedure makedn(upcase_zeile:str255; var dateiname: str60);
  function  saven(channel:integer):str60;
  FUNCTION  WochenTag (Datum : str8) : str2;
  FUNCTION  Channel_ID (Kanal : INTEGER) : Str8;
  function  taste: word;
  FUNCTION  ConstStr (ch : CHAR ; L : INTEGER) : STRING;
  FUNCTION  CutStr (Zeile : STRING) : STRING;
  FUNCTION  UpcaseStr (Zeile : STRING) : STRING;
  PROCEDURE GetString(var S : Str60; L,X,Y : INTEGER; var TC : Char );
  FUNCTION  LPT1_Error : BOOLEAN;
  PROCEDURE Convert_ctrl_O_ctrl_M (VAR Zeile : Str255);


implementation


(* Gibt den TNC-Identifier von KANAL zurueck *)

FUNCTION Channel_ID (* Kanal : INTEGER) : str8 *);
var B_str   : str8;
BEGIN
  if Kanal = 0 then B_str := Schnitte[poll_Moni].Ident
               else B_str := Schnitte[K[Kanal]^.RS232].Ident;
  if length(B_str) > 0 then B_str := B_str + ' ';
  Channel_ID := B_str;
END;

(* CutStr liefert einen String bis zum ersten Leerzeichen *)

FUNCTION CutStr (* Zeile : STRING) : STRING *) ;
VAR  i  : byte;
BEGIN
  i := Pos(' ',Zeile);
  IF (i = 0) THEN i := Length(Zeile) ELSE Dec(i);
  CutStr := Copy(Zeile,1,i);
END;


FUNCTION UpcaseStr (* (Zeile : STRING) : STRING *) ;
VAR  i   : byte;
BEGIN
  FOR i := 1 TO Length(Zeile) DO
    Zeile[i] := Upcase(Zeile[i]);
  UpcaseStr := Zeile;
END;


FUNCTION LPT1_Error;
BEGIN
  LPT1_Error := ((Port[LPT1_Base + 1] AND 184) <> 152);
END;


(* ConstStr liefert einen String der Lnge L, gefllt mit Zeichen ch *)

FUNCTION ConstStr (* (ch : CHAR ; L : byte) : STRING; *);
VAR B_Str : STRING;
BEGIN
  fillchar(B_str,SizeOf(B_Str),ch);
  if L > 0 then B_Str[0] := Chr(L) else B_Str[0] := #0;
  ConstStr := B_Str;
END;



PROCEDURE GetString(* var S     : Str40;
                          L,X,Y : INTEGER;
                      var TC    : Char      *);

var
  P  : byte;
  Ch : Char;
  cx : boolean;

BEGIN

  Cursor_ein;
  if L > (SizeOf(S) - 1) then L := SizeOf(S) - 1;
  cx:=false;
  p:=length(s);
  GotoXY(X,Y); Write(S,ConstStr('_',L - Length(S)));
  repeat
    GotoXY(X + P,Y); ch := ReadKey;
    ch := UpCase(ch);
    if ch = #8 then ch :=#127;
    if ch = #0 then
    BEGIN
      ch := ReadKey;
      case ch of
        'H'  : ch := ^K;
        'K'  : ch := ^H;
        'P'  : ch := ^V;
        'M'  : ch := ^L;
        #83  : ch := ^G;
        #08  : ch := #127;
        #71  : ch := ^A;
        #79  : ch := ^F;
        #59  : ch := ^X;
        else ch := #255;
      END;
    END;

    if ((NOT cx) and not (ch in [#13,^K,^L,^H,^V,^G,^A,^F,#27,#127])) then
    BEGIN
      cx:=true;
      P := 0;
      S := '';
      GotoXY(X,Y);
      Write(conststr('_',L));
      GotoXY(X,Y);
    END
    else cx:=true;

    case Ch of
      '','','','','','','',
      #32..#126 : if P < L then
                  BEGIN
                    if Length(S) = L then Delete(S,L,1);
                    inc(p);
                    Insert(Ch,S,P);
                    Write(Copy(S,P,L));
                  END;
      ^H        : if P > 0 then dec(p);
      ^L        : if P < Length(S) then inc(P);
      ^A        : P := 0;
      ^F        : P := Length(S);
      ^G        : if P < Length(S) then
                  BEGIN
                    Delete(S,P + 1,1);
                    Write(Copy(S,P + 1,L),'_');
                  END;
      #127      : if P > 0 then
                  BEGIN
                    Delete(S,P,1);
                    Write(^H,Copy(S,P,L),'_');
                    dec(p);
                  END;
      ^X        : BEGIN
                    Write(ConstStr('_',Length(S) - P));
                    Delete(S,P + 1,L);
                  END;
    END;  (*of case*)
  until (ch = #13) OR (ch = #27);
  P := Length(S);
  GotoXY(X + P,Y);
  Write('' :L - P);
  TC := Ch;
  Cursor_aus;

END;


function taste; (* : word; *)
var ch : char;
begin
  repeat until keypressed;
  ch := readkey;
  if (ch = #0) then taste:=256 + ord(readkey)
               else taste:=ord(ch);
end;

function saven;            (* ergebnis ist der dateiname ohne pfad/LW *)
var ch: char; i: byte; hstr : string[20];
begin
  with k[channel]^ do
  begin
    i:=length(save_name);
    repeat
     ch:=save_name[i];
     dec(i);
    until (i<1) or (ch='\') or (ch=':');
    hstr:=save_name;
    if i > 0 then hstr:=copy(save_name,i+2,length(save_name)-i+2);
  end;
  i:= pos('.',hstr);
  if i > 9 then delete(hstr,9,(i-9));   (* file > 8 strings ?! *)
  saven:=hstr;
end;


procedure makedn(upcase_zeile:str255; var dateiname: str60);
 begin
   delete(upcase_zeile,1,pos(' ',upcase_zeile));
   while (upcase_Zeile[1] = ' ') and
         (length(upcase_Zeile) > 0) do  delete(upcase_Zeile,1,1);
   DateiName := upcase_Zeile;
   if dateiname[1]='\'     then dateiname:=copy(drive,1,2)+dateiname;
   if DateiName[2]<>':'    then DateiName := Drive + DateiName;
   if pos('.',DateiName)=0 then DateiName := DateiName + '.TXT';
 end;


FUNCTION WochenTag;   (* Liefert zu einem Datum den Wochentag *)
CONST WoTagStr = 'SoMoDiMiDoFrSa';
var  Tag, Monat, Jahr, i : INTEGER;
     x, y, z, Fehler     : INTEGER;
BEGIN
  val(copy(Datum,1,2),Tag,Fehler);
  if Fehler = 0 then val(copy(Datum,4,2),Monat,Fehler);
  if Fehler = 0 then val(copy(Datum,7,2),Jahr,Fehler);
  if Fehler = 0 then
  BEGIN
    inc(Jahr,1900);
    if Monat > 2 then dec(Monat,2)
      else
      BEGIN
        inc(Monat,10);
        dec(Jahr);
      END;
    x := Jahr MOD 100;
    z := Jahr DIV 100;
    y := (13 * Monat - 1) DIV 5 + x DIV 4 + z DIV 4;
    i := (x + y + Tag - 2 * z) MOD 7;
    IF (i >= 0) AND (i <= 6) THEN Wochentag := Copy(WoTagStr,1+2*i,2)
                             ELSE Wochentag := 'xx';
  END
  else WochenTag := 'xx';
END;


PROCEDURE Filereset; (* var datei: text *)
BEGIN
  {$I-} reset(datei); {$I+}
  if ioresult <> 0 then
    begin
     writeln(#10,#10,^G'File nicht gefunden! Programm abgebrochen!');
     halt(0);
    end;
END;


FUNCTION HEX;
const HexDigit : array[0..15] of char = '0123456789ABCDEF';
      Wert : array[1..8] of longInt = (268435456,16777216,1048576,65536,
                                       4096,256,16,1);
var  OutStr   : string[8];
     i,Stelle : INTEGER;

BEGIN
  OutStr[0] := chr(Stellenzahl);
  for Stelle := (9-Stellenzahl) to 8 do
  BEGIN
    i := Dezimal DIV Wert[Stelle];
    Dezimal := Dezimal - i * Wert[Stelle];
    if (i >= 0) and (i <= 15) then OutStr[Stelle-8+Stellenzahl] := HexDigit[i]
                              else OutStr[Stelle-8+Stellenzahl] := 'X';
  END;
  HEX := OutStr;
END;


FUNCTION FormatStr;
var  B_Str   : string;
BEGIN
  str(Dezimal:Stellenzahl,B_Str);
  FormatStr := B_Str;
END;


PROCEDURE beep;
BEGIN  NoSound; Sound(Ton); delay(Laenge); NoSound; END;


PROCEDURE triller;
var   i     : byte;
BEGIN
  for i := 1 to 6 do
  BEGIN
    beep(880,40); beep(1200,40);
  END;
  delay(30);
END;

(* Klingel beim Connect *)

PROCEDURE C_Bell;
VAR i: integer;
Begin
 i := 100;
 repeat
  inc(i,20); Sound(i); Delay(1);
 until i > 2000;
 NoSound;
End;

(* Klingel beim Disconnect *)

PROCEDURE D_Bell;
var i: integer;
BEGIN
 i := 2000;
 repeat
  dec(i,20); Sound(i); Delay(1);
 until i < 100;
 NoSound;
End;

(* Klingel wenn Daten auf anderen Kanal eintreffen *)

PROCEDURE Daten_Bell;
Begin  beep(1400,50); Delay(40); beep(1400,50); End;


FUNCTION str_int;
var i, Zahl : INTEGER;
BEGIN
  Val(Zeile,Zahl,i);
  IF (i <> 0) THEN Zahl := 0;
  Str_Int := Zahl;
END;

procedure clr_FileMenue;
 var   i1   : byte;
Begin
   for i1 := 5 to 8 do
   Begin
     gotoxy(4,i1); write(copy(space,1,31+pfad_ueber));
   End;
   gotoxy(4,10); write(copy(space,1,31+pfad_ueber));
End;


procedure File_error; (* Fname: str60 = Filename wird bergeben *)
begin
  clr_filemenue;
  gotoxy(4,5);  write('Fehler beim Versuch');
  gotoxy(4,6);  write('''',Fname,'''');
  gotoxy(8,7);  write(' zu ffnen!');
  gotoxy(4,10); write(weiter);
  wd:=taste;
end;

(*
    Das SaveFile oeffnen. Wenn es nicht existiert, dann wird es neu
    angelegt, andernfalls wird es zum APPENDen vorbereitet.
*)

PROCEDURE openSaveFile;
BEGIN
  with K[Kanal]^ do
  BEGIN
    (*$I-*)   reset(RXFile);    (*$I+*)
    if IOResult <> 0 then
    BEGIN                  (* File nicht vorhanden, also neues file machen *)
      (*$I-*) rewrite(RXFile);  (*$I+*)
      if ioresult <> 0 then  save:=false;    (* also pfad/anderer error da *)
    END
    else
    BEGIN
      if eof(RXFile) then
      BEGIN
        close(RXFile);
        rewrite(RXFile);
      END
      else appEND(RXFile);
    END;
  END;
END;




FUNCTION Date;               (* gibt Datumstring zurueck, z.B 'Di 19.05.87' *)

const Wochentag = 'SoMoDiMiDoFrSa';

var
  Tag, WoTag, Monat, Jahr               : WORD;
  TagStr, WotagStr, MonatStr, JahrStr   : string[2];

BEGIN (* Date *)

  GetDate(Jahr, Monat, Tag, WoTag);  (* PROCEDURE im Unit DOS *)
  str(Tag:2,TagStr);       str(Monat:2,MonatStr);
  str(Jahr-1900,JahrStr);  str(WoTag,WoTagStr);
  WotagStr := copy(Wochentag,Wotag*2+1,2);
  if Tag < 10 then TagStr[1] := '0';
  if Monat < 10 then MonatStr[1] := '0';
  Date := WotagStr + ' ' + TagStr + '.' + MonatStr + '.' + JahrStr;

END;




FUNCTION Time;           (* Gibt einen ZeitString zurueck, z.B. '18:34:56' *)

var
  Std,min,sek,sek100     : Word;
  StdStr,MinStr,SekStr   : string[2];

BEGIN (* Time *)
      GetTime(Std,Min,Sek,Sek100);
      str(Std:2,StdStr);  str(Min:2,MinStr);  str(Sek:2,SekStr);
      if Std < 10 then Stdstr[1] := '0';
      if Min < 10 then MinStr[1] := '0';
      if Sek < 10 then SekStr[1] := '0';
      Time := StdStr + ':' + MinStr + ':' + SekStr;
END;


FUNCTION GetCursorSize:INTEGER;    (* get Cursorgroesse (aus PCT von DD6CV) *)
BEGIN
  reg.ah:=$03;  INTR($10,reg);
  GetCursorSize:=reg.cx;
END;


PROCEDURE SetCursorSize(Size:INTEGER); (*  Setzt Cursor (aus PCT von DD6CV) *)
BEGIN
  reg.ah:=$01;  reg.cx:=Size;  INTR($10,reg);
END;


PROCEDURE Cursor_aus;            (* Schaltet Cursor aus (aus PCT von DD6CV) *)
CONST  CursorOffBit=8192;
BEGIN
  SetCursorSize(GetCursorSize OR CursorOffBit);
END;


PROCEDURE Cursor_ein;            (* Schaltet Cursor ein (aus PCT von DD6CV) *)
CONST  CursorOnMask=-8193;
BEGIN
  SetCursorSize(GetCursorSize AND CursorOnMask);
END;


FUNCTION int_str;
var b_str  : str8;
BEGIN
  str(i,b_str);
  int_str := b_str;
END;




PROCEDURE Fenster; (* X, Y, B, H : INTEGER; Kopf : str80)  *)

var k     : byte;
    Leer  : string[80];
    Quer  : string[80];
    AMerk : byte;
BEGIN
  AMerk := TextAttr;  TextAttr := norm;
  k:=y;
  Leer :=#186+copy(space,1,(br-2))+#186;
  Quer := conststr(#205,(br-2));
  gotoxy(X,Y);  write(#201,Quer,#187); inc(y);
  if length(kopf) >= (br-2) then kopf:=copy(kopf,1,(br-2))
  else begin
         kopf:=copy(space,1,(br-2-length(kopf)) div 2 ) + kopf;
         kopf:=kopf+copy(space,1,(br-2-length(kopf)));
       end;
  gotoxy(X,Y);  write(#186);
  textattr:=neg_fett; write(kopf);
  textattr:=norm;     write(#186); inc(y);
  gotoxy(X,Y);  write(#204,Quer,#185); inc(y);
  repeat   gotoxy(X,Y);  write(leer);  inc(y);  until y>(k+ho-4);
  gotoxy(X,Y);  write(#204,Quer,#185); inc(y);
  gotoxy(X,Y);  write(Leer);           inc(y);
  gotoxy(X,Y);  write(#200,quer,#188);
  TextAttr := AMerk;
END;


(* Das Bild des angezeigten Kanals neu aufbauen *)

PROCEDURE Neu_Bild;
var Zeilen   : INTEGER;
BEGIN
  move(K[show]^.line,Bild[VideoOfs,1],480); (* die ersten 3 Zeilen *)
  Zeilen := K[show]^.Trenn - 4;
  move(K[show]^.page[4001-Zeilen*160],Bild[VideoOfs,481],Zeilen*160);
  if show = 0 then
  BEGIN
    Zeilen := 22;
    move(K[0]^.Page[4001-Zeilen*160],Bild[VideoOfs,4001-Zeilen*160],Zeilen*160);
  END
  else
  BEGIN
    Zeilen := 25 - K[show]^.Trenn;
    if Zeilen > 0 then
      move(K[0]^.Page[4001-Zeilen*160],Bild[VideoOfs,4001-Zeilen*160],Zeilen*160);
  END;
  Status2;
  Neu_Bild_if_keypressed := false;
END;


(*
   Zeichen auf der zweiten Statuszeile darstellen
   Ausgabe nur auf Schirm und nicht ins RAM  !!
*)

PROCEDURE Status2Out(X_Pos,Attr:INTEGER ; Zeile:str80);
var AMerker   : byte;
    i         : byte;
    ch        : char;
    Position  : INTEGER;
BEGIN
  AMerker := TextAttr;
  case Attr of
   0 : TextAttr := neg;
   1 : TextAttr := neg_fett;
   2 : TextAttr := neg_blink;
  END;
  with K[show]^ do
  BEGIN
    if show = 0 then Position := 480 + pred(X_Pos shl 1)
                else Position := pred(Trenn) * 160 + pred(X_Pos shl 1);
    for i := 1 to length(Zeile) do
    BEGIN
      ch := Zeile[i];
      Bild[VideoOfs,Position] := ch;
      inc(Position);
      Bild[VideoOfs,Position] := chr(TextAttr);
      inc(Position);
    END;
  END;
  TextAttr := AMerker;
END;


(*
   Ausgabe der (kompletten) zweiten Statuszeile
*)

PROCEDURE Status2;

CONST dunkel = 0;
      hell   = 1;
      blink  = 2;

var   Kanal,i  : INTEGER;
      x_Pos    : INTEGER;
BEGIN
  if Kanal_Anzahl < 9 then x_Pos := 2 else x_Pos := 1;
  Status2Out(1,dunkel,ConstStr(' ',80));
  FOR Kanal := 1 to maxLink do
  WITH K[Kanal]^ DO BEGIN
    if poll then
    BEGIN
      IF (Kanal = show)
        THEN Status2Out(x_Pos,hell,chr(Kanal+48)+':')
        ELSE Status2Out(x_Pos,dunkel,chr(Kanal+48)+':');
      IF connected
        THEN
          BEGIN
            i := pos('-',Call);
            IF (i = 0) THEN i := Length(Call) + 1;
            IF NochNichtGelesen
              THEN Status2Out(x_Pos+2,blink,copy(Call,1,i-1))
              ELSE Status2Out(X_Pos+2,hell,copy(Call,1,i-1));
          END
        ELSE
          IF NochNichtGelesen
            THEN Status2Out(x_Pos+2,blink,'discon')
            ELSE Status2Out(x_Pos+2,dunkel,'discon');
      inc(x_Pos,9);
    END;
  END;
END;

PROCEDURE Convert_ctrl_O_ctrl_M;   (* Auf Wunsch von DG5OAX *)
VAR i    : byte;
BEGIN
  FOR i := 1 TO Length(Zeile) DO
    IF Zeile[i] = ^O
      THEN Zeile[i] := ^M;
END;


END.
