(*
   P R L I B 1 . P A S
   Packet-Library-Routinen fuer die Turbo 4.0 Version
   DL1BHO, im August 1988
*)

unit PRLIB1;


interface

uses crt,
     dos,

     PRDEFS,
     PRLIB;

type str1 = string[1];

procedure Maske;
procedure ConfigLesen;
function  Uebergabe(Zeile : str20) : boolean;
procedure Merkerfile_Lesen;
procedure AttributFile_Lesen;
procedure msgFile_lesen;
procedure Catalog(pfad:str60);
function parmstr : str1;


implementation


procedure Maske;
Begin
  clrscr;
  TextAttr := 7;
  writeln('                         ');
  writeln('                       ');
  writeln('                                  ');
  writeln('                                               ');
  writeln('                                         ');
  writeln('                                               ');
  writeln('                                     ');
  writeln('                                     ');
  writeln('                                        ');
  writeln;
  writeln('                                 ');
  writeln('                            ');
  writeln('                               ');
  writeln('                                                ');
  writeln('                                       ');
  writeln('                                             ');
  writeln('                                          ');
  writeln('                                 ');
  writeln('                                ');
  writeln;
  write(' Version ',copy(v1_str,3,length(v1_str)-2),'  ');
  TextAttr := 15;
  writeln('DL1BHO, 11/88. New CMDs: DJ0HC  REMOTE: DF1RW 02/89');
  writeln('        SCROLL  &  Last Revision at ',update,' by DG6MAY');
  TextAttr := 7;
  writeln('      IBM-PC XT/AT + TNC-1/TNC-2 + WA8DED-kompatible Hostmode-Software');
End;


procedure ConfigLesen;
VAR  j   : INTEGER; b:boolean;
const ft = #7#13'Fehler im CONFIG-FILE !' ;

 function Printer_Par (Zeile : str80) : str4;
 var
   i,n           : Integer;
   Anzahl        : Integer;
   Zahl1         : Integer;
   Result        : Integer;
   b_str         : str4;
 begin
   b_str := '';
   val(Copy(Zeile,1,1),Anzahl,Result);
   if Result<>0 then
   Begin
     anzahl:=0;
     if Klingel then write(^G);
   End;
   if (anzahl > 0) and (anzahl < 5) then
   Begin
     for n := 1 to anzahl do
     begin
       Val(Copy(Zeile,4*N-1,3),zahl1,Result);
       if result <>0 then
       Begin
         zahl1 := 0;
         if Klingel then write(^G);
       End;
       b_str := b_str + chr(zahl1);
     end;
   End;
   Printer_Par := b_str;
 end;

Begin (* ConfigLesen *)
{$IFNDEF SP}  gotoxy(1,25); write('CONFIG.PR '); clreol;
{$ELSE} write('.'); {$ENDIF}
  Filereset(config);
  readln(Config,Zeile);  VideoCard := Zeile[1];
  readln(Config,Zeile);  val(cutstr(Zeile),BaudRate,i);
  readln(Config,Zeile);  Hardware := ord(Zeile[1]) - 48;
  readln(Config,Zeile);  Drive := upcasestr(CutStr(Zeile));
  if drive[length(drive)] <> '\' then drive:=drive+'\';
  Merk_Drive := Drive;
  IF Length (Drive) > 13 THEN Pfad_Ueber := Length (Drive) - 13
                         ELSE Pfad_Ueber := 0;
  readln(Config,Zeile);  val(cutstr(Zeile),ScreenInit,i);
  readln(Config,Zeile);
    for i := 1 to 10 do
      Begin
        readln(Config,Zeile);
        Printer1[i] := Printer_Par(Zeile);
      End;

  readln(Config,Zeile);

  for i := 1 to 4 do
  Begin
    readln(Config,Zeile);
    j := Ord(Zeile[5]) - 48;
    b:=(zeile[3]='*');
    if b and (j > maxtnc) then
    begin
      WRITELN(ft,'(MAXTNC)'); halt(0);
    END;
    Schnitte[j].TNC := b;
    Delete(Zeile,1,6);
    Schnitte[j].Ident := CutStr(Zeile);
  End;

  Kanal_Anzahl := 0;
  for Kanal := 1 to maxLink do
  Begin
    readln(Config,Zeile);
    j := Ord(Zeile[5]) - 48;  (* TNC-Nummer *)
    if (j > maxtnc) then
    begin
      WRITELN(ft,'(MAXTNC)'); halt(0);
    END;
    WITH K[Kanal]^ DO BEGIN
      IF Schnitte[j].TNC THEN poll := (Zeile[3] = '*')
                         ELSE poll := FALSE;
      RS232 := j;
      TNCKanal := chr(ord(Zeile[7])-48);
      save_m := (Zeile[9] = 'S');
      Umlaut := (Zeile[11] = 'U');
      if poll then Inc(Kanal_Anzahl);
    END;
  End;

  readln(Config,Zeile);
  READLN(Config,Zeile);
  IF (Copy(Zeile,1,1) <> '<') THEN BEGIN
    WRITELN(ft); Halt(0);
  END;

  FOR i := 1 TO 10 DO WITH AutoCMD[i] DO BEGIN
    Anzahl := 0;
    CMD_Line := '';
    READLN(Config,Zeile);
    Zeile := UpcaseStr(Zeile);
    WHILE (Zeile[1] <> '<') DO BEGIN
      Inc(Anzahl);
      CMD_Line := CMD_Line + Chr(Anzahl) + Zeile;
      READLN(Config,Zeile);
    End;
    CMD_Line := CMD_Line + Chr(Anzahl+1);
  END;

  readln(Config,AlarmCalls);  AlarmCalls := UpcaseStr(AlarmCalls);
  i := pos(';',AlarmCalls);
  if i <> 0 then DELETE(AlarmCalls,i,length(AlarmCalls)-i+1);
  Readln(Config,Zeile);
  LogMerker := CutStr(Zeile);
  LogMerker := ConstStr(' ',3-Length(LogMerker)) + LogMerker;
  close(Config);
  ScreenTimer := ScreenInit;
End;


(* Feststellen, ob der String ZEILE beim Prog.Aufruf uebergeben wurde *)

function Uebergabe (* Zeile : str20) : boolean *);
var merker    : boolean;
    i,k       : integer;
    b_str     : string[30];
Begin
  merker := false;
  for i := 1 to paramcount do
  Begin
    b_str := upcasestr(paramstr(i));
    if b_str = Zeile then merker := true;
  End;
  Uebergabe := merker;
End;


PROCEDURE Merkerfile_Lesen;
VAR PacLenStr  : string[10];
    i,i1,i2    : INTEGER;
Begin
  {$IFNDEF SP}  write('MERKER.TXT ');
  {$ELSE} write('.');  {$ENDIF}
  Filereset(mfile);
  readln(MFile,Zeile);

  for Kanal := 1 to maxLink do
  Begin
    readln(MFile,Zeile);
    if pos('dis',Zeile) = 0 then
    Begin
      with K[Kanal]^ do
      Begin
        Call := Zeile;
        readln(MFile,Zeile);
        qsoDatum := Zeile;
        readln(MFile,Zeile);
        qsoBeginn := Zeile;
        readln(MFile,Zeile);
        ConText := Zeile;
        connected := true;
      End;
    End
    else
    Begin
      for i := 1 to 3 do readln(MFile,Zeile);
    End;
  End;

  for Kanal := 0 to maxLink do
  Begin
    readln(MFile,Zeile);
    PacLenStr := CutStr(Zeile);
    with K[Kanal]^ do
    Begin
      val(PacLenStr,PacLen,i);
      if i <> 0 then PacLen := 128;

      i := Pos('@',Zeile);
      IF i <> 0 THEN
        BEGIN
          Save_Name := Copy(Zeile,i+1,Length(Zeile)-i);
          Delete(Zeile,i,Length(Zeile)-i+1);
        END
        ELSE Save_Name := Drive + 'F' + chr(Kanal+48) + '.TXT';

      if NOT save_m then save_m := (pos('S',Zeile) <> 0);
      Auto       := (pos('A',Zeile) <> 0);
      Umlaut     := (pos('U',Zeile) <> 0) or umlaut;
      (* wenn im config (Stelle 11) oder hier: umlaut ein *)
      if Kanal = 0 then
      Begin
        Klingel    := (pos('K',Zeile) <> 0);
        Time_Stamp := (pos('T',Zeile) <> 0);
        i := Pos('Z:',Zeile);
        IF (i <> 0) THEN
          BEGIN
            VAL(CutStr(Copy(Zeile,i+2,2)),i1,i2);
            IF (i2 = 0)
              THEN
                FOR i2 := 1 TO maxLink DO
                  K[i2]^.Trenn := i1;
          END;
      End;
    End;
  End;

  readln(MFile,Zeile);  val(Zeile,Resync_Z,i);
  readln(MFile,Zeile);  val(Zeile,gesStd,i);
  readln(MFile,Zeile);  val(Zeile,gesMin,i);
  close(MFile);
End;


procedure AttributFile_Lesen;
Begin
  {$IFNDEF SP} write('ATTRIB.TXT ');  {$ELSE} write('.'); {$ENDIF}
  Filereset(afile);
  if (videocard='2') or (videocard='3') then videoofs:=0 (*MONOCHROME/HERCULES*)
                                        else videoofs:=8;(*CGA/LCD/EGA*)
  if (videocard<'1') or (videocard>'6') then
     begin
        writeln(^M^G'Falsche Konfiguration im CONFIG.PR !!!');
        halt(0);
      end;

  repeat
    readln(AFile,Zeile);
  until copy(Zeile,1,3) = '<<' + VideoCard;

  readln(AFile,Zeile);  norm := str_int(CutStr(Zeile));
  readln(AFile,Zeile);  low := str_int(CutStr(Zeile));
  readln(AFile,Zeile);  blink := str_int(CutStr(Zeile));
  readln(AFile,Zeile);  neg := str_int(CutStr(Zeile));
  readln(AFile,Zeile);  neg_fett := str_int(CutStr(Zeile));
  readln(AFile,Zeile);  ctrlAttrib := str_int(CutStr(Zeile));
  readln(AFile,Zeile);  neg_blink := str_int(CutStr(Zeile));
  readln(AFile,Zeile);  conRXAttrib := str_int(CutStr(Zeile));
  readln(AFile,Zeile);  conTXAttrib := str_int(CutStr(Zeile));
  readln(AFile,Zeile);  MoniInfoAttrib := str_int(CutStr(Zeile));
  readln(AFile,Zeile);  MoniHeaderAttrib := str_int(CutStr(Zeile));
  readln(AFile,Zeile);  NetzHeaderAttrib := str_int(CutStr(Zeile));
  IF (NetzHeaderAttrib = 0) THEN NetzHeaderAttrib := MoniInfoAttrib;
  close(AFile);
End;


procedure msgFile_lesen;
var msgNummer  : integer;
    msgZeiger  : integer;
    i          : integer;

Begin
  {$IFNDEF SP}  write('PR.MSG '); {$ELSE} write('.'); {$ENDIF}
  fillchar(msg,sizeof(msg),#0);
  Filereset(msgfile);

  readln(msgFile,Zeile);    (* &<1> ueberlesen *)
  for msgNummer := 1 to 10 do
  Begin
    msgZeiger := 1;
    readln(msgFile,Zeile);
    Zeile := Zeile + #13;
    while (Zeile[1] <> '&') do
    Begin
      for i := 1 to length(Zeile) do
      Begin
       if msgZeiger <= 255 then msg[msgNummer,msgZeiger] := Zeile[i];
       if (msg[msgnummer,msgzeiger]='G') and (msgzeiger > 1) and
          (msg[msgnummer,msgzeiger-1]='^') then
       begin
        dec(msgzeiger);
        msg[msgnummer,msgzeiger]:=#7;
       end;
       inc(msgZeiger);
      End;
      readln(msgFile,Zeile);
      Zeile := Zeile + #13;
    End;
  End;
  (* hier wird, falls vorhanden ctext/disctext (max 80 char) eingelesen,
     ansonsten werden vordefinierte texte genommen (siehe prdefs) *)
  if not(eof(msgfile)) then
  begin
    readln(msgfile,zeile); if zeile[1] <> '&' then ctext:=zeile;
    readln(msgfile,zeile); if zeile[1] <> '&' then disct:=zeile;
  end;
  close(msgFile);

  (* Testen, ob CMD-File vorhanden *)
  {$IFNDEF SP}  write('PR.CMD '); {$ELSE} write('.'); {$ENDIF}
  Filereset(cmdfile);

  (* Testen, ob NETROM-PasswortFile vorhanden ist *)
  assign(NRPWFile,SysPfad+'NETROM.PWF');
  {$I-}  reset(NRPWFile);  {$I+}
  if IOResult = 0 then   (* NETROM-PWFile ist vorhanden *)
  Begin
    close(NRPWFile);
    NR_remote := true;
  End;

End;



PROCEDURE Catalog (* pfad : str60 *);

VAR
      i           : INTEGER;
      FileExt     : STRING[3];
      PunktPos    : INTEGER;
      free        : LONGINT;
      Laenge      : STRING[10];
      Eintrag     : INTEGER;
      Zaehler     : INTEGER;
      x_pos       : INTEGER;
      AMerk       : BYTE;

      SRec        : SearchRec;  (* Im Unit DOS definiert *)

Begin
  AMerk := TextAttr;
  IF (Pos(':',Pfad) = 0) THEN
  Begin
    if pfad[1]<>'\' then Pfad := Drive + Pfad;
    if (pos(':',Pfad) = 0) then           (* Aktuelles Laufwerk feststellen *)
      begin getdir(0,zeile); pfad:=copy(zeile,1,2)+pfad;  end;
  End;
  if (length(pfad)>4) and (pfad[length(pfad)]<>'\') then
    begin
     if ( pos('.', copy(pfad,length(pfad)-3,4))=0 )  or
        ( pos('..',copy(pfad,length(pfad)-3,4))>0 )  then Pfad:=  Pfad + '\*.*';
    end
  else pfad:=pfad+'*.*';
  FindFirst(Pfad,Archive + Directory,SRec);     (* Prozedur im Unit DOS *)

  CLRSCR;  TextAttr := neg;
  WRITE(ConstStr(' ',79));
  GotoXY(3,1);  WRITE('Verzeichnis von ',Pfad);
  TextAttr := norm;
  GotoXY(1,24); WRITE(ConstStr('',79));

  Eintrag := 0;
  Zaehler := 0;
  x_Pos := 1;
  GotoXY(x_Pos,3);

  WHILE (DosError = 0) DO BEGIN
    WITH SRec DO BEGIN
      Inc(Eintrag);
      Inc(Zaehler);
      PunktPos := pos('.',Name);

      IF (Attr <> Directory) THEN BEGIN                 (* kein Dir-Eintrag *)
        if (PunktPos <> 0) THEN BEGIN
          FileExt := copy(Name,PunktPos+1,length(Name)-PunktPos);
          delete(Name,PunktPos,1+length(Name)-PunktPos);
        end
        else FileExt := '';

        FileExt := FileExt + ConstStr(' ',3-Length(FileExt));
        Name := Name + ConstStr(' ',8-length(Name));

        Str(Size,Laenge);
        Laenge := ConstStr(' ',7-Length(Laenge)) + Laenge;
        GotoXY(X_Pos,whereY);
        TextAttr := norm;
        WRITE(Name,' ',FileExt);
        TextAttr := low;
        WRITELN(Laenge);
      END
      ELSE BEGIN                                            (* Dir-Eintrag *)
        GotoXY(X_Pos,whereY);
        TextAttr := norm;
        WRITE(Name,ConstStr(' ',12-Length(Name)));
        TextAttr := low;
        WRITELN('<dir>');
      END;

      IF (Zaehler MOD 21) = 0 THEN
      Begin
        inc(x_Pos,26);
        GotoXY(X_Pos,3);
      End;

      IF Zaehler = 63 THEN
      Begin
        GotoXY(1,25); TextAttr := norm;
        write('Seite voll. ',weiter);
        wd:=taste;
        WINDOW(1,2,80,25); CLRSCR;
        WINDOW(1,1,80,25);
        Zaehler := 0; x_Pos := 1;
        GotoXY(x_Pos,3);
      End;

      FindNext(SRec);

    End; (* with SRec do ... *)

  End; (* while DosError ... *)

  free := DiskFree(ord(Pfad[1]) - 64) DIV 1024;

  GotoXY(1,25);  TextAttr := norm;
  IF (Eintrag = 0) THEN WRITE('Kein Eintrag') ELSE WRITE(Eintrag,' Files');
  WRITE(', ',free,' KByte frei. ',weiter);
  wd:=Taste;
  Neu_Bild;

  TextAttr := AMerk;

End;



{-----------------------------------------------------------------------------}

function parmstr : str1;
var h: integer; hs: string;
begin
 h:=paramcount; hs:=''; parmstr:='';
 if (h>0) then hs:=paramstr(1);
 if length(hs)=1 then parmstr:=hs;
end;

{-----------------------------------------------------------------------------}

end.

